--dummy gamemode for LOVE to handle
gamemode = {}

-- Include Simple Tiled Implementation into project
local sti = require "libraries.sti.init"

function gamemode.load()
    --player_tile = love.graphics.newImage("gfx/player/racial_dolls/human_m.png")

    -- Load map file
    map = sti("tiled/test.lua")

    -- Create new dynamic data layer called "Sprites" as the last layer (tiles + objects + sprites)
    local layer = map:addCustomLayer("Sprites", 3)

    -- Get player spawn object
    local player
    for k, object in pairs(map.objects) do
        if object.name == "Player" then
            player = object
            break
        end
    end

    -- Create player object
    local sprite = love.graphics.newImage("gfx/player/racial_dolls/human_m.png")
    layer.player = {
        sprite = sprite,
        x      = player.x,
        y      = player.y,
        ox     = sprite:getWidth() / 2,
        oy     = sprite:getHeight() / 2
    }
    print("Player x: "..player.x..", y: "..player.y)
  
        -- Add controls to player
    layer.update = function(self, dt)
        -- 96 pixels per second
        local speed = 96

        -- Move player up
        if love.keyboard.isDown("w") or love.keyboard.isDown("up") then
            self.player.y = self.player.y - speed * dt
            print("Player y is..", self.player.y)
        end

        -- Move player down
        if love.keyboard.isDown("s") or love.keyboard.isDown("down") then
            self.player.y = self.player.y + speed * dt
            print("Player y is..", self.player.y)
        end

        -- Move player left
        if love.keyboard.isDown("a") or love.keyboard.isDown("left") then
            self.player.x = self.player.x - speed * dt
            print("Player x is..", self.player.x)
        end

        -- Move player right
        if love.keyboard.isDown("d") or love.keyboard.isDown("right") then
            self.player.x = self.player.x + speed * dt
            print("Player x is..", self.player.x)
        end
        
        print("Player x:"..self.player.x.." y: "..self.player.y)
        
    end
  
        -- Draw player
    layer.draw = function(self)
        print("Drawing player", self.player.x, self.player.y)
        love.graphics.draw(
            self.player.sprite,
            math.floor(self.player.x),
            math.floor(self.player.y),
            0,
            1,
            1,
            self.player.ox,
            self.player.oy
        )

        -- Temporarily draw a point at our location so we know
        -- that our sprite is offset properly
        love.graphics.circle("fill", math.floor(self.player.x), math.floor(self.player.y), 5)
    end

    -- Remove unneeded object layer
    map:removeLayer("Spawn Point")
end

function gamemode.update(dt)
    --print("Updating map")
    -- Update world
    map:update(dt)
end

function gamemode.draw()
    -- Scale world
    local scale = 1
    local screen_width = love.graphics.getWidth() / scale
    local screen_height = love.graphics.getHeight() / scale
    
    -- Translate world so that player is always centred
    local player = map.layers["Sprites"].player
    local tx = math.floor(player.x - love.graphics.getWidth() / 2)
    local ty = math.floor(player.y - love.graphics.getHeight() / 2)
    
        -- Transform world
    love.graphics.scale(scale)
    love.graphics.translate(-tx, -ty)
    
    -- Draw world
    map:draw()
end